<!--
Copyright 2007, Google Inc.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. Neither the name of Google Inc. nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<!DOCTYPE html>

<html>
<head>
<title>Google Gears WorkerPool Demo</title>
<link rel="stylesheet" type="text/css" href="sample.css">
<style>

p.results {
  margin: 4px;
}

</style>
</head>

<body onload="init()" id="theBody">
<h1>Google Gears WorkerPool Demo</h1>
<div id="view-source">&nbsp;</div>

<p id="status">

<p>
<table>
<tr>
<td valign=top>Interact with UI:</td>
<td><input type="button" value="Interact" onclick="interact();">
</td>
<td></td>
</tr>
<tr>
<td valign=top>Run expensive computation:</td>
<td>
    <input type="button" id="syncButton"
           value="Synchronous" onclick="syncComputation();">
</td>
<td><i>Note the synchronous computation blocks UI interaction
       (and may even cause an 'unresponsive script' warning).</i>
</td>
</tr>
<tr>
<td>
</td>
<td>
    <input type="button" id="asyncButton"
           value="Asynchronous" onclick="asyncComputation();">
</td>
<td>
    <i>But you can still interact while the asynchronous computation
       runs in a JavaScript worker.</i>
</td>
</tr>
</table>

<div id="results" style="font-size: 120%";>
<p style="font-weight: bold;" class="results">Results
</div>

<!-- ====================================== -->
<!-- End HTML code.  Begin JavaScript code. -->

<script src="../gears_init.js"></script>
<script src="sample.js"></script>
<script>

function init() {
  insertRow('Hello, threaded JavaScript.');
  parentInit();
}

function insertRow(message) {
  var results = getElementById('results');
  var id = 'message' + (childNodes(results).length + 1);
  results.innerHTML += '<p class="results" id="' + id + '">';
  setTextContent(getElementById(id), message);
}

//
// WorkerPool code
//

var workerPool = null;
var childId;

function parentInit() {
  if (!window.google || !google.gears) {
    return;
  }

  try {
    workerPool =
        google.gears.factory.create('beta.workerpool');
  } catch (e) {
    document.getElementById('asyncButton').disabled = true;
    setError('Could not create workerpool: ' + e.message);
    return;
  }

  // set the parent's message handler
  workerPool.onmessage = parentHandler;

  // setup the entire body of JavsScript code to run in the worker
  var childCode = String(childInit) +
                  String(childHandler) +
                  'childInit();';  // runs init function

  // create the worker
  try {
   childId = workerPool.createWorker(childCode);
  } catch (e) {
   setError('Could not create worker: ' + e.message);
  }

  // Child workers will always set onmessage before createWorker() returns.
  insertRow('Parent initialized.');
}

function parentHandler(msg, sender) {
  insertRow('Asynchronous result: ' + msg);
}


function childInit() {
  google.gears.workerPool.onmessage = childHandler;
}

function childHandler(msg, sender) {

  var cmd = msg.substr(0, 4);
  var arg = msg.substr(5);
  if (cmd == 'fibo') {
    var result = fibonacci(arg);
    google.gears.workerPool.sendMessage(String(result), sender);
  } else if (cmd == 'iden') {
    var result = identity(arg);
    google.gears.workerPool.sendMessage(String(result), sender);
  } else {
    google.gears.workerPool.sendMessage('Unknown command.', sender);
  }

  function fibonacci(n) {
    var result = 1;
    var prevResult = 0;
    while (n > 0) {
      var temp = result;
      result += prevResult;
      prevResult = temp;
      n--;
    }
    return result;
  }

  function identity(n) {
    var result = 0;
    while (n > 0) {
      result += 1;
      var tempString = 'abc' + '123';  // for slowdown
      n--;
    }
    return result;
  }

}

//
// UI-related functions
//

var uiToggleState = 0;
function interact() {
  if (uiToggleState) {
    getElementById('theBody').style.backgroundColor = '#FFFFFF';
    uiToggleState = 0;
  } else {
    getElementById('theBody').style.backgroundColor = '#CCCCCC';
    uiToggleState = 1;
  }
}

function asyncComputation() {
  if (workerPool) {
    var message = 'iden:2501234';
    workerPool.sendMessage(message, childId);
  }
}

function syncComputation() {
  var result = identity(2501234);
  insertRow('Synchronous result: ' + String(result));

  function identity(n) {
    var result = 0;
    while (n > 0) {
      result += 1;
      var tempString = 'abc' + '123';  // for slowdown
      n--;
    }
    return result;
  }
}

</script>
</body>
</html>
